commit aca7d4e8790bff32ee749936bb0224d873c46052
Author: Thomas Rodgers <rodgert@twrodgers.com>
Date:   Fri Dec 10 00:35:25 2021

    libstdc++: Make atomic<T*>::wait() const [PR102994]
    
    This was an oversight in the original commit adding wait/notify
    to atomic<T>.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/102994
            * include/bits/atomic_base.h (__atomic_base<_PTp*>::wait()):
            Add const qualifier.
            * include/std/atomic (atomic<_Tp*>::wait(), atomic_wait()):
            Likewise.
            * testsuite/29_atomics/atomic/wait_notify/102994.cc:
            New test.
    
    (cherry picked from commit 38c60e5075f89265a560eab166d43247624a7535)

diff --git a/libstdc++-v3/include/bits/atomic_base.h b/libstdc++-v3/include/bits/atomic_base.h
index 20cf1343c58..2db35722ce0 100644
--- a/libstdc++-v3/include/bits/atomic_base.h
+++ b/libstdc++-v3/include/bits/atomic_base.h
@@ -902,7 +902,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 #if __cpp_lib_atomic_wait
       _GLIBCXX_ALWAYS_INLINE void
       wait(__pointer_type __old,
-	   memory_order __m = memory_order_seq_cst) noexcept
+	   memory_order __m = memory_order_seq_cst) const noexcept
       {
 	std::__atomic_wait_address_v(&_M_p, __old,
 				     [__m, this]
diff --git a/libstdc++-v3/include/std/atomic b/libstdc++-v3/include/std/atomic
index 9b1fb15ac41..fdffacc35df 100644
--- a/libstdc++-v3/include/std/atomic
+++ b/libstdc++-v3/include/std/atomic
@@ -637,9 +637,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 					    __cmpexch_failure_order(__m));
       }
 
-#if __cpp_lib_atomic_wait 
+#if __cpp_lib_atomic_wait
     void
-    wait(__pointer_type __old, memory_order __m = memory_order_seq_cst) noexcept
+    wait(__pointer_type __old, memory_order __m = memory_order_seq_cst) const noexcept
     { _M_b.wait(__old, __m); }
 
     // TODO add const volatile overload
@@ -1421,12 +1421,12 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 
   template<typename _Tp>
     inline void
-    atomic_notify_one(atomic<_Tp>* __a) noexcept
+    atomic_notify_one(const atomic<_Tp>* __a) noexcept
     { __a->notify_one(); }
 
   template<typename _Tp>
     inline void
-    atomic_notify_all(atomic<_Tp>* __a) noexcept
+    atomic_notify_all(const atomic<_Tp>* __a) noexcept
     { __a->notify_all(); }
 #endif // __cpp_lib_atomic_wait
 
diff --git a/libstdc++-v3/testsuite/29_atomics/atomic/wait_notify/102994.cc b/libstdc++-v3/testsuite/29_atomics/atomic/wait_notify/102994.cc
new file mode 100644
index 00000000000..9d92ff954f1
--- /dev/null
+++ b/libstdc++-v3/testsuite/29_atomics/atomic/wait_notify/102994.cc
@@ -0,0 +1,19 @@
+// { dg-options "-std=gnu++20" }
+// { dg-do compile { target c++20 } }
+// { dg-require-gthreads "" }
+
+#include <atomic>
+
+void
+test1(const std::atomic<char*>& a, char* p)
+{
+  a.wait(p);
+}
+
+void
+test2(const std::atomic<int>* a, int v)
+{
+  std::atomic_wait(a, v);
+  std::atomic_notify_one(a);
+  std::atomic_notify_all(a);
+}

